//+------------------------------------------------------------------+
//|                                                   avalanchv0.mq4 |
//|                                                     Oleg Tsarkov |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Oleg Tsarkov"
#property link      "http://www.metaquotes.net"
#property show_confirm


//---- input parameters
extern string    First=" ";
extern bool      UseFirst=true; //  
extern double    FIter0Lot=0.1;
extern int       FIter0TP=50;
extern int       FIter0SL=50;
extern double    FIter1Lot=0.2;
extern int       FIter1TP=50;
extern int       FIter1SL=50;
extern double    FIter2Lot=0.4;
extern int       FIter2TP=50;
extern int       FIter2SL=50;
extern double    FIter3Lot=0.8;
extern int       FIter3TP=50;
extern int       FIter3SL=50;
extern double    FIter4Lot=1.6;
extern int       FIter4TP=50;
extern int       FIter4SL=50;
extern double    FIter5Lot=3.2;
extern int       FIter5TP=50;
extern int       FIter5SL=50;
extern double    FIter6Lot=6.4;
extern int       FIter6TP=50;
extern int       FIter6SL=50;
extern double    FIter7Lot=12.8;
extern int       FIter7TP=50;
extern int       FIter7SL=50;
extern double    FIter8Lot=25.0;
extern int       FIter8TP=50;
extern int       FIter8SL=50;
extern double    FIter9Lot=50.0;
extern int       FIter9TP=50;
extern int       FIter9SL=50;
extern string    Second=" ";
extern bool      UseSecond=true; //  
extern double    SIter0Lot=0.1;
extern int       SIter0TP=70;
extern int       SIter0SL=70;
extern double    SIter1Lot=0.2;
extern int       SIter1TP=70;
extern int       SIter1SL=70;
extern double    SIter2Lot=0.4;
extern int       SIter2TP=70;
extern int       SIter2SL=70;
extern double    SIter3Lot=0.8;
extern int       SIter3TP=70;
extern int       SIter3SL=70;
extern double    SIter4Lot=1.6;
extern int       SIter4TP=70;
extern int       SIter4SL=70;
extern double    SIter5Lot=3.2;
extern int       SIter5TP=70;
extern int       SIter5SL=70;
extern double    SIter6Lot=6.4;
extern int       SIter6TP=70;
extern int       SIter6SL=70;
extern double    SIter7Lot=12.8;
extern int       SIter7TP=70;
extern int       SIter7SL=70;
extern double    SIter8Lot=25.0;
extern int       SIter8TP=70;
extern int       SIter8SL=70;
extern double    SIter9Lot=50.0;
extern int       SIter9TP=70;
extern int       SIter9SL=70;
extern int       Iter0Trend=0; //   , (0- , 1-  )
extern int       FSDiff=30;//        

int       FIter0Trend;
int       FMagic=111111;
string    FComment="0"; //   
int       SIter0Trend;
int       SMagic=222222;
string    SComment="0"; //   
int RPips;
string CurGIterName;

//Kim=================================================================
//-------   -----------------------------------------------+
bool   gbDisabled    = False;          //   
color  clOpenBuy     = LightBlue;      //    
color  clOpenSell    = LightCoral;     //    
int    Slippage      = 3;              //  
int    NumberOfTry   = 5;              //   
bool   UseSound      = True;           //   
string NameFileSound = "expert.wav";   //   

//-------    -----------------------------------------+
#include <stdlib.mqh>                  //  

//Kim End===================================================================
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
GlobalVariableSet("P"+DoubleToStr(FMagic,0),GetPriceLastOpenPos(NULL,FMagic));
GlobalVariableSet("P"+DoubleToStr(SMagic,0),GetPriceLastOpenPos(NULL,SMagic));


   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
   //        
   double FPrice=GlobalVariableGet("P"+DoubleToStr(FMagic,0));
   double SPrice=Ask;
   double RPrice=FPrice-SPrice;
   if (RPrice<0) RPrice=-RPrice;
   RPips=RPrice/Point;
   //  
   if (UseFirst==true)
      {
         FIter0Trend=TrendPMZ(30,Iter0Trend);
         WorkExp(FMagic,FIter0Trend,
            FIter0Lot,FIter0TP,FIter0SL,
            FIter1Lot,FIter1TP,FIter1SL,
            FIter2Lot,FIter2TP,FIter2SL,
            FIter3Lot,FIter3TP,FIter3SL,
            FIter4Lot,FIter4TP,FIter4SL,
            FIter5Lot,FIter5TP,FIter5SL,
            FIter6Lot,FIter6TP,FIter6SL,
            FIter7Lot,FIter7TP,FIter7SL,
            FIter8Lot,FIter8TP,FIter8SL,
            FIter9Lot,FIter9TP,FIter9SL);
      }
   
   if (UseSecond==true)// && FSDiff<RPips && FPrice!=-1
      {
         SIter0Trend=TrendPMZ(30,1);
         WorkExp(SMagic,SIter0Trend,
            SIter0Lot,SIter0TP,SIter0SL,
            SIter1Lot,SIter1TP,SIter1SL,
            SIter2Lot,SIter2TP,SIter2SL,
            SIter3Lot,SIter3TP,SIter3SL,
            SIter4Lot,SIter4TP,SIter4SL,
            SIter5Lot,SIter5TP,SIter5SL,
            SIter6Lot,SIter6TP,SIter6SL,
            SIter7Lot,SIter7TP,SIter7SL,
            SIter8Lot,SIter8TP,SIter8SL,
            SIter9Lot,SIter9TP,SIter9SL);
      }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//
void WorkExp(int Magic,int Iter0Trend,
         double Iter0Lot,int Iter0TP,int Iter0SL,
         double Iter1Lot,int Iter1TP,int Iter1SL,
         double Iter2Lot,int Iter2TP,int Iter2SL,
         double Iter3Lot,int Iter3TP,int Iter3SL,
         double Iter4Lot,int Iter4TP,int Iter4SL,
         double Iter5Lot,int Iter5TP,int Iter5SL,
         double Iter6Lot,int Iter6TP,int Iter6SL,
         double Iter7Lot,int Iter7TP,int Iter7SL,
         double Iter8Lot,int Iter8TP,int Iter8SL,
         double Iter9Lot,int Iter9TP,int Iter9SL)
   {
      int CurOrdType;
      //     
      double CurOpenType=GetTypeLastOpenPos(NULL,Magic);
      // -    
      GlobalVariableSet("P"+DoubleToStr(Magic,0),GetPriceLastOpenPos(NULL,Magic));
      if (CurOpenType!=-1) return;
      //  -    
      double CurCloseProfit=GetProfitLastClosePos(NULL,Magic);
         if (CurCloseProfit==-999999) // 
            {
            //   Magic  Iter0Trend  Iter0Lot,Iter0TP,Iter0SL
               if (RPips<FSDiff&&Magic==SMagic) return;
               if (Iter0Trend==-1)
                  {
                     SetOrder(NULL, OP_SELL, Iter0Lot, Bid,Ask+Iter0SL*Point, Bid-Iter0TP*Point, Magic, 0,"0");
                  }
               if (Iter0Trend==1) 
                  {
                     SetOrder(NULL, OP_BUY, Iter0Lot, Ask,Bid-Iter0SL*Point, Ask+Iter0TP*Point, Magic, 0,"0");
                  }
               return;
            }
         if (CurCloseProfit!=-999999)//
            {
            // 
               if (RPips<FSDiff&&Magic==SMagic) return;
               if (CurCloseProfit>=0)// 
                  {
                     if (RPips<FSDiff&&Magic==SMagic) return;
                     //   Magic  Iter0Trend  Iter0Lot,Iter0TP,Iter0SL
                     //  "0"
                     if (Iter0Trend==-1)
                        {
                           SetOrder(NULL, OP_SELL, Iter0Lot, Bid,Ask+Iter0SL*Point, Bid-Iter0TP*Point, Magic, 0,"0");
                        }
                     if (Iter0Trend==1) 
                        {
                           SetOrder(NULL, OP_BUY, Iter0Lot, Ask,Bid-Iter0SL*Point, Ask+Iter0TP*Point, Magic, 0,"0");
                        }
                     return;
                  }
               if (CurCloseProfit<0)// 
                  {
                     //    
                     int CurCloseType=GetTypeLastClosePos(NULL,Magic);
                     int CurCloseIter=GetIntCommentLastClosePos(NULL,Magic);
                     //  =9
                        //   Magic  Iter0Trend  Iter0Lot,Iter0TP,Iter0SL
                        //  "0"
                     if (CurCloseIter==9) //9============================
                        {
                           if (RPips<FSDiff&&Magic==SMagic) return;
                           if (Iter0Trend==-1)
                              {
                                 SetOrder(NULL, OP_SELL, Iter0Lot, Bid,Ask+Iter0SL*Point, Bid-Iter0TP*Point, Magic, 0,"0");
                              }
                           if (Iter0Trend==1) 
                              {
                                 SetOrder(NULL, OP_BUY, Iter0Lot, Ask,Bid-Iter0SL*Point, Ask+Iter0TP*Point, Magic, 0,"0");
                              }
                           return;   
                        }
            
                     //  <9
                        //      Magic  Iter?Trend  Iter?Lot,Iter?TP,Iter?SL
                        //  " +1"
                     if (CurCloseIter<9) 
                        {
                           int RevCurCloseType;
                           if (CurCloseType==OP_SELL) {RevCurCloseType=OP_BUY;}
                           if (CurCloseType==OP_BUY) {RevCurCloseType=OP_SELL;}
                           switch (CurCloseIter)
                              {
                                 case 0:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter1Lot, Ask,Bid-Iter1SL*Point, Ask+Iter1TP*Point, Magic, 0,"1");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter1Lot, Bid,Ask+Iter1SL*Point, Bid-Iter1TP*Point, Magic, 0,"1");
                                       }
                                    break;
                                 case 1:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter2Lot, Ask,Bid-Iter2SL*Point, Ask+Iter2TP*Point, Magic, 0,"2");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter2Lot, Bid,Ask+Iter2SL*Point, Bid-Iter2TP*Point, Magic, 0,"2");
                                       }
                                    break;
                                 case 2:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter3Lot, Ask,Bid-Iter3SL*Point, Ask+Iter3TP*Point, Magic, 0,"3");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter3Lot, Bid,Ask+Iter3SL*Point, Bid-Iter3TP*Point, Magic, 0,"3");
                                       }
                                    break;
                                 case 3:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter4Lot, Ask,Bid-Iter4SL*Point, Ask+Iter4TP*Point, Magic, 0,"4");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter4Lot, Bid,Ask+Iter4SL*Point, Bid-Iter4TP*Point, Magic, 0,"4");
                                       }
                                    break;
                                 case 4:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter5Lot, Ask,Bid-Iter5SL*Point, Ask+Iter5TP*Point, Magic, 0,"5");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter5Lot, Bid,Ask+Iter5SL*Point, Bid-Iter5TP*Point, Magic, 0,"5");
                                       }
                                    break;
                                 case 5:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter6Lot, Ask,Bid-Iter6SL*Point, Ask+Iter6TP*Point, Magic, 0,"6");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter6Lot, Bid,Ask+Iter6SL*Point, Bid-Iter6TP*Point, Magic, 0,"6");
                                       }
                                    break;
                                 case 6:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter7Lot, Ask,Bid-Iter7SL*Point, Ask+Iter7TP*Point, Magic, 0,"7");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter7Lot, Bid,Ask+Iter7SL*Point, Bid-Iter7TP*Point, Magic, 0,"7");
                                       }
                                    break;
                                 case 7:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter8Lot, Ask,Bid-Iter8SL*Point, Ask+Iter8TP*Point, Magic, 0,"8");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter8Lot, Bid,Ask+Iter8SL*Point, Bid-Iter8TP*Point, Magic, 0,"8");
                                       }
                                    break;
                                 case 8:
                                    if (RevCurCloseType==OP_BUY)
                                       {
                                          SetOrder(NULL, OP_BUY, Iter9Lot, Ask,Bid-Iter9SL*Point, Ask+Iter9TP*Point, Magic, 0,"9");
                                       }
                                    if (RevCurCloseType==OP_SELL)
                                       {
                                          SetOrder(NULL, OP_SELL, Iter9Lot, Bid,Ask+Iter9SL*Point, Bid-Iter9TP*Point, Magic, 0,"9");
                                       }
                                    break;
                              }
                           return;  
                        }
                     
                     return;
                  }
            }
   }         


//=====================================================================
//    
   int TrendPMZ(int CurPeriod,int IndicatorType) 
      {
         // 
         if (IndicatorType==0) 
            {
               MathSrand(TimeLocal());
               if (MathRand() > 16384) return(1);
               if (MathRand() <= 16384) return(-1);
               return(0);
            }   
         // 
         if (IndicatorType==1) 
            {
            double Rez1Up=iCustom(NULL,CurPeriod,"Supertrend",0,1);
            double Rez1Dn=iCustom(NULL,CurPeriod,"Supertrend",1,1);
            if (Rez1Up>0&&Rez1Up<10000) return(1);
            if (Rez1Dn>0&&Rez1Dn<10000) return(-1);
            return(0);
            }   

      }
//+----------------------------------------------------------------------------+
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :       -1               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetTypeLastClosePos(string sy="", int mn=-1) {
  datetime t;
  int      i, k=OrdersHistoryTotal(), r=-1;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (t<OrderCloseTime()) {
            t=OrderCloseTime();
            r=OrderType();
          }
        }
      }
    }
  }
  return(r);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :       -999999               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetProfitLastClosePos(string sy="", int mn=-1) {
  datetime t;
  int      i, k=OrdersHistoryTotal(); 
  double r=-999999;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (t<OrderCloseTime()) {
            t=OrderCloseTime();
            r=OrderProfit();
          }
        }
      }
    }
  }
  return(r);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :  int      -1               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetIntCommentLastClosePos(string sy="", int mn=-1) {
  datetime t;
  int      i, k=OrdersHistoryTotal(), r=-1;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_HISTORY)) {
      if ((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (t<OrderCloseTime()) {
            t=OrderCloseTime();
            r=StrToInteger(OrderComment());
          }
        }
      }
    }
  }
  return(r);
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :       -1               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
int GetTypeLastOpenPos(string sy="", int mn=-1) {
  datetime t;
  int      i, k=OrdersTotal(), r=-1;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (t<OrderOpenTime()) {
            t=OrderOpenTime();
            r=OrderType();
          }
        }
      }
    }
  }
  return(r);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 19.02.2008                                                     |
//|   :       -1               |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    mn - MagicNumber                (-1   -  )                    |
//+----------------------------------------------------------------------------+
double GetPriceLastOpenPos(string sy="", int mn=-1) {
  datetime t;
  int      i, k=OrdersTotal();
  double r=-1;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (mn<0 || OrderMagicNumber()==mn)) {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (t<OrderOpenTime()) {
            t=OrderOpenTime();
            r=OrderOpenPrice();
          }
        }
      }
    }
  }
  return(r);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 12.03.2008                                                     |
//|   :    .                         |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (""   -  ,                   |
//|                                     NULL -  )                 |
//|    op -                    (-1   -  )                    |
//|    mn - MagicNumber                (-1   -  )                    |
//|    ot -               ( 0   -   )          |
//+----------------------------------------------------------------------------+
bool ExistOrders(string sy="", int op=-1, int mn=-1, datetime ot=0) {
  int i, k=OrdersTotal(), ty;

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      ty=OrderType();
      if (ty>1 && ty<6) {
        if ((OrderSymbol()==sy || sy=="") && (op<0 || ty==op)) {
          if (mn<0 || OrderMagicNumber()==mn) {
            if (ot<=OrderOpenTime()) return(True);
          }
        }
      }
    }
  }
  return(False);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                                  |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    m -                                                       |
//+----------------------------------------------------------------------------+
void Message(string m) {
  Comment(m);
  if (StringLen(m)>0) Print(m);
}
//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 01.09.2005                                                     |
//|   :                          |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    op -                                       |
//+----------------------------------------------------------------------------+
string GetNameOP(int op) {
  switch (op) {
    case OP_BUY      : return("Buy");
    case OP_SELL     : return("Sell");
    case OP_BUYLIMIT : return("Buy Limit");
    case OP_SELLLIMIT: return("Sell Limit");
    case OP_BUYSTOP  : return("Buy Stop");
    case OP_SELLSTOP : return("Sell Stop");
    default          : return("Unknown Operation");
  }
}

//+----------------------------------------------------------------------------+
//|      :   . aka KimIV,  http://www.kimiv.ru                   |
//+----------------------------------------------------------------------------+
//|     : 13.03.2008                                                     |
//|   :  .                                              |
//+----------------------------------------------------------------------------+
//|  :                                                                |
//|    sy -     (NULL  "" -  )          |
//|    op -                                                            |
//|    ll -                                                                 |
//|    pp -                                                                |
//|    sl -                                                         |
//|    tp -                                                         |
//|    mn - Magic Number                                                       |
//|    ex -                                                       |
//|    cc -                                                         |
//+----------------------------------------------------------------------------+
void SetOrder(string sy, int op, double ll, double pp,
              double sl=0, double tp=0, int mn=0, datetime ex=0, string cc="") {
  color    clOpen;
  datetime ot;
  double   pa, pb, mp;
  int      err, it, ticket, msl;
  string   lsComm=cc;//WindowExpertName()+" "+GetNameTF(Period());

  if (sy=="" || sy=="0") sy=Symbol();
  msl=MarketInfo(sy, MODE_STOPLEVEL);
  if (op==OP_BUYLIMIT || op==OP_BUYSTOP) clOpen=clOpenBuy; else clOpen=clOpenSell;
  if (ex>0 && ex<TimeCurrent()) ex=0;
  for (it=1; it<=NumberOfTry; it++) {
    if (!IsTesting() && (!IsExpertEnabled() || IsStopped())) {
      Print("SetOrder():   ");
      break;
    }
    while (!IsTradeAllowed()) Sleep(5000);
    RefreshRates();
    ot=TimeCurrent();
    ticket=OrderSend(sy, op, ll, pp, Slippage, sl, tp, lsComm, mn, ex, clOpen);
    if (ticket>0) {
      if (UseSound) PlaySound(NameFileSound); break;
    } else {
      err=GetLastError();
      if (err==128 || err==142 || err==143) {
        Sleep(1000*66);
        if (ExistOrders(sy, op, mn, ot)) {
          if (UseSound) PlaySound(NameFileSound); break;
        }
        Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
        continue;
      }
      mp=MarketInfo(sy, MODE_POINT);
      pa=MarketInfo(sy, MODE_ASK);
      pb=MarketInfo(sy, MODE_BID);
      if (pa==0 && pb==0) Message("SetOrder():       "+sy);
      Print("Error(",err,") set order: ",ErrorDescription(err),", try ",it);
      Print("Ask=",pa,"  Bid=",pb,"  sy=",sy,"  ll=",ll,"  op=",GetNameOP(op),
            "  pp=",pp,"  sl=",sl,"  tp=",tp,"  mn=",mn);
      //  
      if (err==130) {
        switch (op) {
          case OP_BUYLIMIT:
            if (pp>pa-msl*mp) pp=pa-msl*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_BUYSTOP:
            if (pp<pa+(msl+1)*mp) pp=pa+(msl+1)*mp;
            if (sl>pp-(msl+1)*mp) sl=pp-(msl+1)*mp;
            if (tp>0 && tp<pp+(msl+1)*mp) tp=pp+(msl+1)*mp;
            break;
          case OP_SELLLIMIT:
            if (pp<pb+msl*mp) pp=pb+msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
          case OP_SELLSTOP:
            if (pp>pb-msl*mp) pp=pb-msl*mp;
            if (sl>0 && sl<pp+(msl+1)*mp) sl=pp+(msl+1)*mp;
            if (tp>pp-(msl+1)*mp) tp=pp-(msl+1)*mp;
            break;
        }
        Print("SetOrder():   ");
      }
      //   
      if (err==2 || err==64 || err==65 || err==133) {
        gbDisabled=True; break;
      }
      //  
      if (err==4 || err==131 || err==132) {
        Sleep(1000*300); break;
      }
      //    (8)     (141)
      if (err==8 || err==141) Sleep(1000*100);
      if (err==139 || err==140 || err==148) break;
      //    
      if (err==146) while (IsTradeContextBusy()) Sleep(1000*11);
      //   
      if (err==147) {
        ex=0; continue;
      }
      if (err!=135 && err!=138) Sleep(1000*7.7);
    }
  }
}
//+----------------------------------------------------------------------------+

